(function (thisObj) {
// ----- EXTENDSCRIPT INCLUDES ------ //
"object"!=typeof JSON&&(JSON={}),function(){"use strict";var rx_one=/^[\],:{}\s]*$/,rx_two=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,rx_three=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,rx_four=/(?:^|:|,)(?:\s*\[)+/g,rx_escapable=/[\\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,rx_dangerous=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta,rep;function f(t){return t<10?"0"+t:t}function this_value(){return this.valueOf()}function quote(t){return rx_escapable.lastIndex=0,rx_escapable.test(t)?'"'+t.replace(rx_escapable,function(t){var e=meta[t];return"string"==typeof e?e:"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+t+'"'}function str(t,e){var r,n,o,u,f,a=gap,i=e[t];switch(i&&"object"==typeof i&&"function"==typeof i.toJSON&&(i=i.toJSON(t)),"function"==typeof rep&&(i=rep.call(e,t,i)),typeof i){case"string":return quote(i);case"number":return isFinite(i)?String(i):"null";case"boolean":case"null":return String(i);case"object":if(!i)return"null";if(gap+=indent,f=[],"[object Array]"===Object.prototype.toString.apply(i)){for(u=i.length,r=0;r<u;r+=1)f[r]=str(r,i)||"null";return o=0===f.length?"[]":gap?"[\n"+gap+f.join(",\n"+gap)+"\n"+a+"]":"["+f.join(",")+"]",gap=a,o}if(rep&&"object"==typeof rep)for(u=rep.length,r=0;r<u;r+=1)"string"==typeof rep[r]&&(o=str(n=rep[r],i))&&f.push(quote(n)+(gap?": ":":")+o);else for(n in i)Object.prototype.hasOwnProperty.call(i,n)&&(o=str(n,i))&&f.push(quote(n)+(gap?": ":":")+o);return o=0===f.length?"{}":gap?"{\n"+gap+f.join(",\n"+gap)+"\n"+a+"}":"{"+f.join(",")+"}",gap=a,o}}"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null},Boolean.prototype.toJSON=this_value,Number.prototype.toJSON=this_value,String.prototype.toJSON=this_value),"function"!=typeof JSON.stringify&&(meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},JSON.stringify=function(t,e,r){var n;if(gap="",indent="","number"==typeof r)for(n=0;n<r;n+=1)indent+=" ";else"string"==typeof r&&(indent=r);if(rep=e,e&&"function"!=typeof e&&("object"!=typeof e||"number"!=typeof e.length))throw new Error("JSON.stringify");return str("",{"":t})}),"function"!=typeof JSON.parse&&(JSON.parse=function(text,reviver){var j;function walk(t,e){var r,n,o=t[e];if(o&&"object"==typeof o)for(r in o)Object.prototype.hasOwnProperty.call(o,r)&&(void 0!==(n=walk(o,r))?o[r]=n:delete o[r]);return reviver.call(t,e,o)}if(text=String(text),rx_dangerous.lastIndex=0,rx_dangerous.test(text)&&(text=text.replace(rx_dangerous,function(t){return"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})),rx_one.test(text.replace(rx_two,"@").replace(rx_three,"]").replace(rx_four,"")))return j=eval("("+text+")"),"function"==typeof reviver?walk({"":j},""):j;throw new SyntaxError("JSON.parse")})}();
// ---------------------------------- //
// ----- EXTENDSCRIPT PONYFILLS -----
function __objectFreeze(obj) { return obj; }
function __isArray(arr) { try { return arr instanceof Array; } catch (e) { return false; } };
// ---------------------------------- //
// Fixed namespace to avoid ExtendScript environment issues
var ns = "__CLIPLO__";

var getFps = function getFps() {
  var seq = app.project.activeSequence;
  var fpsTime = seq.getSettings().videoFrameRate;
  var frameDuration = fpsTime.seconds;
  var fps = 1 / frameDuration;
  return {
    fps: fps,
    frameDuration: frameDuration
  };
};

var getPath = function getPath() {
  return app.project.path;
};

var getTimelineLength = function getTimelineLength() {
  var seq = app.project.activeSequence;
  var latest = 0;
  for (var i = 0; i < seq.videoTracks.numTracks; i++) {
    var vTrack = seq.videoTracks[i];
    for (var j = 0; j < vTrack.clips.numItems; j++) {
      var clip = vTrack.clips[j];
      if (clip.end.seconds > latest) {
        latest = clip.end.seconds;
      }
    }
  }
  for (var _i = 0; _i < seq.audioTracks.numTracks; _i++) {
    var aTrack = seq.audioTracks[_i];
    for (var _j = 0; _j < aTrack.clips.numItems; _j++) {
      var _clip = aTrack.clips[_j];
      if (_clip.end.seconds > latest) {
        latest = _clip.end.seconds;
      }
    }
  }
  return latest;
};

/**
 * Creates J-cuts or L-cuts in Premiere Pro sequence
 * 
 * A J-cut is when the audio of the next clip starts playing before the video appears
 * An L-cut is when the video of the next clip appears before its audio starts playing
 * 
 * @param amountOfFrames - Number of frames to offset the audio/video
 * @param type - "j" for J-cut, "l" for L-cut
 */
var createJCuts = function createJCuts(amountOfFrames, type) {
  // Enable Premiere Pro QE DOM for advanced sequence manipulation
  app.enableQE();

  // Get active sequence references (both regular and QE DOM)
  var seq = app.project.activeSequence;
  var qeSeq = qe.project.getActiveSequence();

  // Get track references for first video and audio tracks
  var audioTrack = qeSeq.getAudioTrackAt(0);
  var videoTrack = qeSeq.getVideoTrackAt(0);
  var regularVideoTrack = seq.videoTracks[0];
  var regularAudioTrack = seq.audioTracks[0];

  // Calculate frame offset based on sequence framerate
  var seqSettings = seq.getSettings();
  var fps = seqSettings.videoFrameRate.seconds;
  var jcutOffset = fps * amountOfFrames * -1;

  // Get total number of clips in sequence
  
  var amountOfClips = regularVideoTrack.clips.length;

  // Store all clip references in an array for easier manipulation
  var clips = [];

  // Collect all clip references (both QE and regular DOM)
  for (var i = 0; i < amountOfClips; i++) {
    var qeVideoClip = videoTrack.getItemAt(i);
    var qeAudioClip = audioTrack.getItemAt(i);
    var regVideoClip = regularVideoTrack.clips[i];
    var regAudioClip = regularAudioTrack.clips[i];
    clips.push({
      qeVideoClip: qeVideoClip,
      qeAudioClip: qeAudioClip,
      regVideoClip: regVideoClip,
      regAudioClip: regAudioClip
    });
  }

  // Process each clip pair (current and previous)
  for (var i = 1; i < clips.length; i++) {
    // Calculate time offset for current clip pair
    var moveDistance = i * jcutOffset;

    // Get references to previous and current clips
    var prev = clips[i - 1];
    var curr = clips[i];

    // For J-cuts, move previous video up, for L-cuts move current video up
    if (type === "j") {
      
      prev.qeVideoClip.moveToTrack(1, 0, "0");
    } else {
      
      curr.qeVideoClip.moveToTrack(1, 0, "0");
    }

    // Alternate audio tracks between clips for better organization
    if (i % 2 !== 0) {
      
      curr.qeAudioClip.moveToTrack(-1, 1, "0");
    }

    // Apply the time offset to both video and audio
    
    curr.regVideoClip.move(moveDistance);
    
    curr.regAudioClip.move(moveDistance);

    // Move video track back to original position
    if (type === "j") {
      
      prev.qeVideoClip.moveToTrack(-1, 1, "0");
    } else {
      
      curr.qeVideoClip.moveToTrack(-1, 1, "0");
    }
  }
};

/**
 * Cuts (razors) the active sequence at a specified time position
 * 
 * @param pos - The position in seconds where the cut should be made
 * @description This function uses Premiere Pro's QE DOM to perform a razor cut
 * at the specified position. It converts the seconds input into the correct
 * timecode format based on the sequence settings.
 * 
 * @requires QE DOM to be enabled
 * @example
 * // Cut sequence at 5 seconds
 * cutAt(5);
 */
var cutAt = function cutAt(pos) {
  // Enable QE DOM which is required for razor functionality
  app.enableQE();

  // Get references to both standard and QE sequence objects
  var seq = app.project.activeSequence;
  var qeSeq = qe.project.getActiveSequence();
  var seqSettings = seq.getSettings();

  // Get sequence timing settings
  var fpsTime = seqSettings.videoFrameRate;
  var displayFormat = seqSettings.videoDisplayFormat;

  // Create time object and convert seconds to proper timecode
  var time = new Time();
  time.seconds = pos;

  // Format the time according to sequence settings
  var frame = time.getFormatted(fpsTime, displayFormat);

  // Perform the razor cut at the specified frame
  
  qeSeq.razor(frame);
};

/**
 * Aligns a time value in seconds to the nearest frame boundary based on the active sequence's frame rate.
 * This ensures that time values correspond exactly to frame positions, preventing sub-frame offsets.
 * 
 * @param seconds - The time value in seconds to align to frame boundaries
 * @returns The frame-aligned time value in seconds
 * 
 * @example
 * // For a 30fps sequence, align 1.516 seconds to nearest frame
 * const alignedTime = alignToFrames(1.516); // Returns 1.5167 (frame 45.5)
 */
var alignToFrames = function alignToFrames(seconds) {
  // Get the active sequence and its settings
  var seq = app.project.activeSequence;
  var seqSettings = seq.getSettings();

  // Get frame rate information
  var fpsTime = seqSettings.videoFrameRate;
  var frameDuration = fpsTime.seconds; // Duration of one frame in seconds
  var fps = 1 / frameDuration; // Frames per second

  // Round to nearest frame boundary by:
  // 1. Multiply by fps to convert to frames
  // 2. Round to nearest whole frame
  // 3. Divide by fps to convert back to seconds
  return Math.round(seconds * fps) / fps;
};

/**
 * Aligns timeline segments to frame boundaries for precise cutting
 * 
 * @param segments - Array of timeline segments to align. Each segment contains:
 *                  - start: Start time in seconds
 *                  - end: End time in seconds
 *                  - videoTracks (optional): Array of video track indices to affect
 *                  - audioTracks (optional): Array of audio track indices to affect
 *                  - allTracks (optional): Whether to affect all tracks
 * @returns Array of timeline segments with start/end times aligned to frame boundaries
 * 
 * @description
 * This function ensures all segment boundaries align with actual frame boundaries
 * in the sequence. This is critical for frame-accurate cutting and segment removal.
 * It processes each segment and aligns both its start and end times to the nearest
 * frame boundaries using the alignToFrames utility.
 * 
 * @example
 * // Align a segment to frame boundaries
 * const alignedSegments = alignSegmentsToFrames([{
 *   start: 1.001, // Will be aligned to nearest frame
 *   end: 2.999,   // Will be aligned to nearest frame
 *   videoTracks: [0, 1]
 * }]);
 */
var alignSegmentsToFrames = function alignSegmentsToFrames(segments) {
  var frameAlignedSegments = [];
  for (var i = 0; i < segments.length; i++) {
    var segment = segments[i];
    var alignedStart = alignToFrames(segment.start);
    var alignedEnd = alignToFrames(segment.end);
    frameAlignedSegments.push({
      start: alignedStart,
      end: alignedEnd,
      videoTracks: segment.videoTracks,
      audioTracks: segment.audioTracks,
      allTracks: segment.allTracks
    });
  }
  return frameAlignedSegments;
};

/**
 * Finds all timeline segments that fully contain a given clip, using frame-accurate tolerance
 * 
 * @param clip - The clip to check
 * @param clip.start - Start time of the clip in seconds
 * @param clip.end - End time of the clip in seconds
 * @param segments - Array of timeline segments to check against
 * @returns Array of timeline segments that fully contain the clip
 * 
 * @description
 * This function checks if a clip falls completely within any timeline segments,
 * using a half-frame tolerance to account for frame boundaries. The tolerance ensures
 * that clips aligned exactly with segment boundaries are properly detected.
 * 
 * The function is used as part of the segment removal process to identify which
 * segments should affect a given clip. A clip is considered "contained" if its
 * start and end times (with tolerance) fall within a segment's boundaries.
 * 
 * @example
 * // Check if a clip from 1-2 seconds falls within any segments
 * const segments = findSegmentForClip(
 *   { start: 1.0, end: 2.0 },
 *   [{ start: 0.5, end: 2.5 }]
 * );
 */
var findSegmentForClip = function findSegmentForClip(clip, segments) {
  var seq = app.project.activeSequence;
  var seqSettings = seq.getSettings();

  // Get frame rate and display format
  var fpsTime = seqSettings.videoFrameRate;
  var frameDuration = fpsTime.seconds;
  var foundSegments = [];
  var tolerance = frameDuration / 2; // Half-frame tolerance
  for (var i = 0; i < segments.length; i++) {
    var segment = segments[i];

    // Check if clip is fully contained within segment with tolerance
    var clipStartsInSegment = clip.start + tolerance >= segment.start;
    var clipEndsInSegment = clip.end - tolerance <= segment.end;
    if (clipStartsInSegment && clipEndsInSegment) {
      foundSegments.push(segment);
    }
  }
  return foundSegments;
};

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (__isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
/**
 * Determines if a clip should be removed based on its position and track information
 * 
 * @param clip - The clip object containing start and end times
 * @param clip.start - Start time of the clip in seconds
 * @param clip.end - End time of the clip in seconds
 * @param segments - Array of timeline segments to check against
 * @param currentTrack - The track number being evaluated
 * @param type - Whether to check video or audio tracks ("videoTracks" | "audioTracks")
 * @returns boolean indicating if the clip should be removed
 * 
 * @description
 * This function checks if a given clip falls within any removal segments and if those
 * segments target either all tracks or specifically the track the clip is on.
 * It's used as part of the segment removal process to determine which clips should
 * be removed from the timeline.
 */
var shouldClipBeRemoved = function shouldClipBeRemoved(clip, segments, currentTrack, type) {
  var shouldClipBeRemoved = false;

  // Check if we find any segments this clip is fully contained in
  var foundSegments = findSegmentForClip({
    start: clip.start,
    end: clip.end
  }, segments);

  // For each found segment we need to check if it targets the current track
  var _iterator = _createForOfIteratorHelper(foundSegments),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var foundSegment = _step.value;
      // If the segment targets all tracks, we need to remove the clip anyway
      if (foundSegment.allTracks) {
        shouldClipBeRemoved = true;
        break;
      }

      // Next, check the actual track (lol so many nested loops, I hate ES3)
      var _iterator2 = _createForOfIteratorHelper(foundSegment[type] || []),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var track = _step2.value;
          if (track === currentTrack) {
            shouldClipBeRemoved = true;
            break;
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return shouldClipBeRemoved;
};

/**
 * Removes segments from a Premiere Pro sequence with frame-accurate precision.
 * This function can remove segments from specific video and audio tracks, or from all tracks if no specific tracks are specified.
 *
 * The function performs the following steps:
 * 1. Aligns all segments to frame boundaries for precise cutting
 * 2. Creates cuts at the start and end of each segment
 * 3. Removes clips that fall entirely within the segments
 * 4. Optionally ripples the sequence to close gaps
 *
 * Frame-accurate behavior:
 * - All segments are automatically aligned to the nearest frame boundaries
 * - A half-frame tolerance is used when determining if clips fall within segments
 * - Segments shorter than one frame are automatically extended to one frame
 *
 * @param segments - Array of timeline segments to remove. Each segment can specify:
 *                  - start: Start time in seconds
 *                  - end: End time in seconds
 *                  - videoTracks (optional): Array of video track indices to affect
 *                  - audioTracks (optional): Array of audio track indices to affect
 *                  If no tracks are specified, the segment will be removed from all tracks.
 * @param ripple - Whether to ripple the sequence after removing segments (default: true).
 *                When true, gaps created by removed segments will be closed.
 *                When false, gaps will remain in the timeline.
 *
 * @example
 * // Remove a segment from all tracks
 * removeSegments([{ start: 1.0, end: 2.0 }], true);
 *
 * @example
 * // Remove a segment from specific video tracks only
 * removeSegments([{
 *   start: 1.0,
 *   end: 2.0,
 *   videoTracks: [0, 1] // Only first two video tracks
 * }], true);
 *
 * @example
 * // Remove a segment from specific audio tracks only
 * removeSegments([{
 *   start: 1.0,
 *   end: 2.0,
 *   audioTracks: [0, 1] // Only first two audio tracks
 * }], true);
 *
 * @example
 * // Remove multiple segments with different track configurations
 * removeSegments([
 *   { start: 1.0, end: 2.0 }, // All tracks
 *   { start: 3.0, end: 4.0, videoTracks: [0] }, // Video track 1 only
 *   { start: 5.0, end: 6.0, audioTracks: [0, 1] } // First two audio tracks
 * ], true);
 */
var removeSegments = function removeSegments(segments) {
  var ripple = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  // Set up sequence variables
  var seq = app.project.activeSequence;
  var seqSettings = seq.getSettings();

  // Get frame rate and display format
  var fpsTime = seqSettings.videoFrameRate;
  fpsTime.seconds;

  // Adjust segments to frame boundaries
  var frameAlignedSegments = alignSegmentsToFrames(segments);

  // Then for each segment, create a cut at the start and the end
  for (var s = 0; s < frameAlignedSegments.length; s++) {
    var segment = frameAlignedSegments[s];
    cutAt(segment.start);
    cutAt(segment.end);
  }

  // Process video tracks
  for (var vTrack = 0; vTrack < seq.videoTracks.numTracks; vTrack++) {
    var videoClips = seq.videoTracks[vTrack].clips;
    for (var v = videoClips.numItems - 1; v >= 0; v--) {
      var clip = videoClips[v];
      var removeClip = shouldClipBeRemoved({
        start: clip.start.seconds,
        end: clip.end.seconds
      }, frameAlignedSegments, vTrack, "videoTracks");
      if (removeClip) {
        clip.remove(ripple, false);
      }
    }
  }

  // Process audio tracks
  for (var aTrack = 0; aTrack < seq.audioTracks.numTracks; aTrack++) {
    var audioClips = seq.audioTracks[aTrack].clips;
    for (var a = audioClips.numItems - 1; a >= 0; a--) {
      var clip = audioClips[a];
      var _removeClip = shouldClipBeRemoved({
        start: clip.start.seconds,
        end: clip.end.seconds
      }, frameAlignedSegments, aTrack, "audioTracks");
      if (_removeClip) {
        clip.remove(ripple, false);
      }
    }
  }
};

/**
 * Exports audio from the active sequence to a specified path using a given EPR preset.
 * When no tracks are specified, exports the full mix of all tracks.
 * When specific tracks are provided, temporarily mutes all other tracks during export.
 *
 * @param {string} audioPath - The destination path where the audio file will be exported
 * @param {string} eprPath - The path to the EPR preset file that defines export settings
 * @param {number[]} [tracksToExport] - Optional array of track indices to export. If omitted, exports all tracks
 *
 * @example
 * // Export all tracks
 * exportAudio("/path/to/output.wav", "/path/to/preset.epr");
 *
 * // Export only tracks 0 and 2
 * exportAudio("/path/to/output.wav", "/path/to/preset.epr", [0, 2]);
 */
var exportAudio = function exportAudio(audioPath, eprPath, tracksToExport) {
  var sequence = app.project.activeSequence;

  // If no tracks specified, export all tracks
  if (!tracksToExport) {
    sequence.exportAsMediaDirect(audioPath, eprPath, 0);
    return;
  }

  // Store original mute states
  var audioTracks = sequence.audioTracks;
  var originalMuteStates = [];
  try {
    // Save original state and mute all tracks
    for (var i = 0; i < audioTracks.numTracks; i++) {
      // Convert boolean to number: true -> 1, false -> 0
      originalMuteStates[i] = audioTracks[i].isMuted() ? 1 : 0;
      audioTracks[i].setMute(1); // 1 for muted, 0 for unmuted in ExtendScript
    }

    // Unmute only the specified tracks
    for (var _i = 0; _i < tracksToExport.length; _i++) {
      var trackIndex = tracksToExport[_i];
      if (trackIndex >= 0 && trackIndex < audioTracks.numTracks) {
        audioTracks[trackIndex].setMute(0);
      }
    }

    // Perform the export
    sequence.exportAsMediaDirect(audioPath, eprPath, 0);
  } finally {
    // Restore original mute states
    for (var _i2 = 0; _i2 < audioTracks.numTracks; _i2++) {
      if (typeof originalMuteStates[_i2] === "number") {
        audioTracks[_i2].setMute(originalMuteStates[_i2]);
      }
    }
  }
};

var backupActiveSequence = function backupActiveSequence() {
  var seq = app.project.activeSequence;
  if (!seq) return null;

  // Find or create Cliplo Backup bin
  var backupBin = null;
  for (var i = 0; i < app.project.rootItem.children.numItems; i++) {
    var item = app.project.rootItem.children[i];
    if (item.name === "Cliplo Backup" && item.type === ProjectItemType.BIN) {
      backupBin = item;
      break;
    }
  }
  if (!backupBin) {
    backupBin = app.project.rootItem.createBin("Cliplo Backup");
  }

  // Store original sequence info
  var originalSequenceId = seq.sequenceID;

  // Create timestamp for the backup name
  var now = new Date();
  var timestamp = now.toUTCString();
  var backupName = "".concat(seq.name, " - Backup ").concat(timestamp);

  // Clone the sequence
  var cloneSuccess = seq.clone();
  if (!cloneSuccess) return null;

  // Find the newly created sequence (it will have " Copy" appended)
  var duplicatedSeq = null;
  for (var _i = 0; _i < app.project.sequences.numSequences; _i++) {
    var sequence = app.project.sequences[_i];
    if (sequence.name === "".concat(seq.name, " Copy")) {
      duplicatedSeq = sequence;
      break;
    }
  }
  if (!duplicatedSeq) return null;

  // Rename and move to backup bin
  duplicatedSeq.name = backupName;

  // Find the ProjectItem for the sequence to move it
  var sequenceProjectItem = null;
  for (var _i2 = 0; _i2 < app.project.rootItem.children.numItems; _i2++) {
    var _item = app.project.rootItem.children[_i2];
    if (_item.name === backupName) {
      sequenceProjectItem = _item;
      break;
    }
  }
  if (sequenceProjectItem) {
    sequenceProjectItem.moveBin(backupBin);
  }

  // Close the backup sequence and refocus the original
  duplicatedSeq.close();
  app.project.openSequence(seq.sequenceID);
  return {
    backupName: backupName,
    originalSequenceId: originalSequenceId
  };
};

var findProjectItemRecursive = function findProjectItemRecursive(root, name, parent) {
  for (var i = 0; i < root.children.numItems; i++) {
    var item = root.children[i];
    if (item.name === name) {
      return {
        item: item,
        parent: parent
      };
    }

    // If this is a bin, search inside it
    if (item.type === ProjectItemType.BIN) {
      var found = findProjectItemRecursive(item, name, item);
      if (found) return found;
    }
  }
  return null;
};
var restoreBackup = function restoreBackup(backupName, originalSequenceId) {
  // Find the original sequence by ID
  var originalSequence = null;
  for (var i = 0; i < app.project.sequences.numSequences; i++) {
    var sequence = app.project.sequences[i];
    if (sequence.sequenceID === originalSequenceId) {
      originalSequence = sequence;
      break;
    }
  }
  if (!originalSequence) return null;
  var originalName = originalSequence.name;
  var rootItem = app.project.rootItem;

  // Find the current sequence and its parent
  var currentFound = findProjectItemRecursive(rootItem, originalName, rootItem);
  if (!currentFound) return null;

  // Find the backup sequence and its parent
  var backupFound = findProjectItemRecursive(rootItem, backupName, rootItem);
  if (!backupFound) return null;
  currentFound.item;
    var originalBin = currentFound.parent;
  var backupItem = backupFound.item;

  // Delete the current sequence
  //currentItem.select();
  app.project.deleteSequence(originalSequence);

  // Move backup to original location and rename it
  backupItem.moveBin(originalBin);
  backupItem.name = originalName;

  // Open the restored sequence
  for (var _i = 0; _i < app.project.sequences.numSequences; _i++) {
    var _sequence = app.project.sequences[_i];
    if (_sequence.name === originalName) {
      app.project.openSequence(_sequence.sequenceID);
      break;
    }
  }
  return {
    success: true,
    restoredName: originalName
  };
};

// get Base Info

var ppro = /*#__PURE__*/__objectFreeze({
  __proto__: null,
  getFps: getFps,
  getPath: getPath,
  getTimelineLength: getTimelineLength,
  createJCuts: createJCuts,
  removeSegments: removeSegments,
  exportAudio: exportAudio,
  backupActiveSequence: backupActiveSequence,
  restoreBackup: restoreBackup
});

var host = typeof $ !== "undefined" ? $ : window;
switch (BridgeTalk.appName) {
  case "premierepro":
  case "premiereprobeta":
    host[ns] = ppro;
    break;
}

// https://extendscript.docsforadobe.dev/interapplication-communication/bridgetalk-class.html?highlight=bridgetalk#appname

})(this);